// 扩展插件
import '../lib/angular-base64/angular-base64.min'

import lineChart from './line-chart'
import bodyTypePane from './body-type-pane'
import dropdown from './dropdown'
import customSubheader from './custom-subheader'
import base64Decode from './base64-decode'
import videoSrc from './video-src'
import finishRepeat from './finish-repeat'
import swiperScroll from './swiper-scroll'
export default angular.module('icare.directives',['base64'])
  /**
   * @ngdoc directive
   * @name lineChart
   * @restrict E
   *
   * @description
   *
   * @param {object=} option
   * @param {number=} val
   */

  .directive('lineChart',lineChart)
  /**
   * @ngdoc directive
   * @name bodyTypePane
   * @restrict E
   *
   * @description
   *
   * @param {string=} bodyType
   */

  .directive('bodyTypePane',bodyTypePane)
  /**
   * @ngdoc directive
   * @name dropdown
   * @restrict E
   *
   * @description
   *
   * @param {string=} title
   */
  .directive('dropdown',dropdown)
  /**
   * @ngdoc directive
   * @name customSubheader
   * @description 作用: 用来动态获取subheader的高度，从而改变content距离顶部距离
   * @param {string=} title
   */
  .directive('customSubheader', customSubheader)
  /**
   * @ngdoc directive
   * @name base64Decode
   * @description 作用: 将内容文本base64解析
   * @param {string=} title
   */
  .directive('base64Decode', base64Decode)
  /**
   * @ngdoc directive
   * @name videoSrc
   * @description 作用: 给video的src赋值
   */
  .directive('videoSrc', videoSrc)
  /**
   * @ngdoc directive
   * @name finishRepeat
   * @description 作用: 轮播图渲染完成时，调用
   */
  .directive('finishRepeat', finishRepeat)
  /**
   * @ngdoc directive
   * @name swiperScroll
   * @description 作用: 轮播图最后一个向右滑动时 和 第一个向左滑动时
   */
  .directive('swiperScroll', swiperScroll)

;
