export default () => {
  return {
    restrict: 'E',
    templateUrl:'directives/line-chart/line-chart.html',
    scope:{
      option:'=',
      val:'='
    },
    link:function ($scope) {
      let option = _.cloneDeep($scope.option),
        maxVal = option.maxVal,
        minVal = option.minVal,
        ranges = _.toArray(option.ranges),
        rangeLen = ranges.length,
        firstRange = _.first(ranges),
        lastRange = _.last(ranges);
      option.ranges = ranges;
      firstRange.min = minVal;
      lastRange.max = maxVal;
      $scope.chartOption = option;

      _.reduce(ranges,function (offset,i) {
        i.percent = ((i.max-i.min)/(maxVal-minVal))*100;
        i.offset = offset;
        return offset+i.percent;
      },0);

      $scope.$watch('val.value',function () {
        if ($scope.val && $scope.val.value) {
          $scope.currentValPercent = (($scope.val.value - minVal) / (maxVal - minVal)) * 100;
          if ($scope.currentValPercent >= 100) {
            $scope.currentValPercent = 100;
          }
        } else {
          $scope.currentValPercent = null;
        }
      });
    }
  }
}
