export default ($http, $ionicPopup, $ionicLoading, $localStorage, $state) => {
  let service = {
    setUserInfo: {
      url: '/tikuapp/user/setUserInfo',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {},
      callback: () => {}
    },
    feedbackInfo: {
      url: '/tikuapp/feedbackInfo',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {},
      callback: () => {}
    },
    // 反馈数据 
    feedbackData: {
      userId: '',
      title: '',
      content: '',
      linkInfo: ''
    },
    getWrong: {
      url: '/tikuapp/user/getErrorList',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        examId: '',
        userId: ''
      },
      callback: () => {}
    },
    getCollection: {
      url: '/tikuapp/user/getCollectList',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        examId: '',
        userId: ''
      },
      callback: () => {}
    },
    getHistory: {
      url: '/tikuapp/user/getCompletedList',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        examId: '',
        userId: ''
      },
      callback: () => {}
    },
    quit: {
      url: '/tikuapp/user/logout',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {},
      callback: () => {}
    },
    getAreaInfo: {
      url: '/www/lib/lCalendar/area.json',
      type: 'GET',
      headers: {},
      data: {},
      callback: () => {}
    },
    /**
     * 统一AJAX 调用方法    后期可提取方法 -- common
     * @param {String} json.type 类型值
     * @param {String} json.url 接口地址
     * @param {Object} json.headers 请求头对象内容
     * @param {Object} json.data 请求内容对象
     * @param {Function} json.callback 请求结束回调函数
     */
    ajax: (json) => {
      $http({
        method: json.type,
        url: BASE_PATH + json.url,
        headers: json.headers,
        data: json.data
      }).then((data, status) => {
        json.callback && json.callback(data, status);
      }, (data, status) => {
        json.callback && json.callback(data, status);
      });
    },
    /**
     * 判断是否为空方法    后期可提取方法 -- common
     * @param {String} val 传入对应的变量值
     */
    isNaN: (val) => {
      return (val == '' || val == undefined || val == null) ? true : false;
    },
    /**
     * 获取本地缓存文件中的数据    后期可提取方法 -- common 
     * @param {String} key 传入对应的变量名
     */
    getLocalItem: (key) => {
      return $localStorage[key];
    },
    /**
     * 设置本地缓存文件中的数据    后期可提取方法 -- common
     * @param {String} key 传入对应的变量名
     * @param {Object} val 传入对应的要存储的值
     */
    setLocalItem: (key, val) => {
      $localStorage[key] = val;
    },
    /**
     * 路由指向某个页面    后期可提取方法 -- common
     * @param {String} name 传入对应的变量名
     */
    goState: (name) => {
      $state.go(name);
    },
    /**
     * 系统提示框 自定义弹框 显示    后期可提取方法 -- common
     * @param {String} json.title 错误信息
     * @param {Number} json.num 错误信息
     */
    sysShow: (json) => {
      $ionicLoading.show({ template: json.title, duration: json.num });
    },
    /**
     * 系统提示框 自定义弹框 隐藏    后期可提取方法 -- common
     */
    sysHide: () => {
      $ionicLoading.hide();
    },
    /**
     * 修改提示框 自定义弹框
     * @param {String} json.title 错误信息
     * @param {Function} json.callback 对应回调函数
     */
    editPopup: (json) => {
      let myPopup1 = $ionicPopup.show({
        title: json.title,
        cssClass: 'account-editPopup',
        buttons: [{
          text: '确定',
          type: 'scene-inp3',
          onTap: function(e) {
            json.callback && json.callback(e);
          }
        }]
      });
    },
    /**
     * 修改提示框 自定义弹框
     * @param {String} json.title 标题
     * @param {String} json.subTitle 副标题
     * @param {String} json.modelStr 模型字符串
     * @param {Object} json.scope 当前作用域传入
     * @param {Function} json.callback 对应回调函数
     */
    setPopup: (json) => {
      let myPopup2 = $ionicPopup.show({
        template: '<input type="text" placeholder="请输入" value="{{'+json.modelStr+'}}" ng-model="'+json.modelStr+'">',
        title: json.title,
        subTitle: json.subTitle,
        cssClass: 'account-setPopup',
        scope: json.scope,
        buttons: [
          { text: '取消' },
          {
            text: '确定',
            type: 'scene-inp3',
            onTap: function(e) {
              json.callback && json.callback(e);
            }
          }
        ]
      });
    }
  }

  return service;
}
