export default ($scope, $stateParams, AccountSvr) => {
    // 修改性别
    $scope.changeSex = (i) => {
        $scope.info.sex = i;
        setUserInfo();
    }
    // 修改昵称
    $scope.setUserName = () => {
        let temp = $scope.info.userName;
        AccountSvr.setPopup({
            title: '更改昵称',
            subTitle: '支持中英文、数字，30个字符以内',
            modelStr: 'info.userName',
            scope: $scope,
            callback: () => {
                if($scope.info.userName.length <= 30) {
                    setUserInfo();
                } else {
                    $scope.info.userName = temp;
                    AccountSvr.sysShow({ title: '不符合要求，修改失败', num: '1000' });
                }
            }
        });
    }
    // 如果昵称、报考地址、考试信息变动，更新
    $scope.updateInfo = () => {
        setUserInfo();
    }
    // 区域选择插件 初始化
	AccountSvr.getAreaInfo.callback = (json) => {
        $scope.areaData = new LArea();
        $scope.areaData.init({
            'trigger': '#areaUser', //触发选择控件的文本框，同时选择完毕后name属性输出到该位置
            'valueTo': '#areaUserIds', //选择完毕后id属性输出到该位置
            'keys': {
                id: 'id',
                name: 'name',
                parentid: 'parentid'
            }, //绑定数据源相关字段 id对应valueTo的value属性输出 name对应trigger的value属性输出
            'type': 1, //数据源类型
            'data': json.data //数据源
        }); 
    };
    AccountSvr.ajax(AccountSvr.getAreaInfo);

    // AJAX 设置个人信息
    let setUserInfo = () => {
        // AccountSvr.sysShow({ title: '修改中', num: '5000' });
        AccountSvr.setUserInfo.data = $scope.info;
        AccountSvr.setUserInfo.headers = {
            TIKU_AUTH_TOKEN: AccountSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
		AccountSvr.setUserInfo.callback = (data, status) => {
			if(data.data.code != 0) {
				AccountSvr.sysShow({ title: data.data.errMsg, num: '1000' });
			} else {
                AccountSvr.sysHide();
                // 刚进入时，传入id为1，禁止弹框
                !$stateParams.id && AccountSvr.sysShow({ title: '修改成功', num: '1000' });
                $stateParams.id = 0;
                // 更新成功后 需要更新 localStorage

                // 放到AJAX回调里面
                let temp = AccountSvr.getLocalItem('user');
                temp.userid = $scope.info.userId;
                temp.username = $scope.info.userName;
                temp.sex = $scope.info.sex;
                temp.examname = $scope.info.examName;
                temp.examid = $scope.info.examId;
                temp.locationaddress = $scope.info.examLocation;
                temp.locationcode = $scope.info.examLocId;
                temp.imgUrl = '';
                AccountSvr.setLocalItem('user', temp);
			}
		};
        AccountSvr.ajax(AccountSvr.setUserInfo);
    }
    
    $scope.doRefresh = () => {
        // 获取 用户基本信息
        let temp = AccountSvr.getLocalItem('user');

        // 报考地、报考科目
        $scope.info = {
            userId: temp.userid,
            userName: temp.username,
            sex: temp.sex,
            examName: temp.examname,
            examId: temp.examid,
            examLocation: temp.locationaddress,
            examLocId: temp.locationcode,
            imgUrl: ''
        }
        
        setUserInfo();
    }


    // 进入或返回该页面时，刷新页面数据
    $scope.$on('$ionicView.beforeEnter', $scope.doRefresh);
}
