export default ($scope, ExamSvr, $ionicHistory) => {
    $scope.exam = ExamSvr.params;
    $scope.exam.examName = '请选择考试类型';
    $scope.exam.examId = '';
    $scope.exam.examLocation = '请选择考地';
    $scope.exam.examLocId = '';
    // 区域选择插件 初始化
	ExamSvr.getAreaInfo.callback = (json) => {
        $scope.areaData = new LArea();
        $scope.areaData.init({
            'trigger': '#area', //触发选择控件的文本框，同时选择完毕后name属性输出到该位置
            'valueTo': '#areaIds', //选择完毕后id属性输出到该位置
            'keys': {
                id: 'id',
                name: 'name',
                parentid: 'parentid'
            }, //绑定数据源相关字段 id对应valueTo的value属性输出 name对应trigger的value属性输出
            'type': 1, //数据源类型
            'data': json.data //数据源
        });
        
        $scope.areaData.value = [0,0,0]; //控制初始位置，注意：该方法并不会影响到input的value
    };
    ExamSvr.ajax(ExamSvr.getAreaInfo);

    // 确定
    $scope.confirm = () => {
        // 输入为空 验证
		if($scope.exam.examName == '请选择考试类型') {
            ExamSvr.sysHide();
			ExamSvr.sysShow({ title: '未选择考试类型', num: '1000' });
			return ;
		} else if($scope.exam.examLocation == '请选择考地') {
            ExamSvr.sysHide();
			ExamSvr.sysShow({ title: '未选择考地', num: '1000' });
			return ;
        }
        // AJAX 提交考试调用
        ExamSvr.examUpdate.data = ExamSvr.params;
        ExamSvr.params.userId = ExamSvr.getLocalItem('user').userid;
        ExamSvr.params.examLocId = document.querySelector('#areaIds').value.split('/').join(',');
        ExamSvr.examUpdate.headers = {
            TIKU_AUTH_TOKEN: ExamSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
		ExamSvr.examUpdate.callback = (data, status) => {
			if(data.data.code != 0) {
				ExamSvr.sysShow({ title: data.data.errMsg, num: '1000' });
			} else {
                // 更新 考试地点信息进入缓存
                let temp = ExamSvr.getLocalItem('user');
                temp.locationaddress = $scope.exam.examLocation;
                temp.locationcode = $scope.exam.examLocId;
                ExamSvr.setLocalItem('user', temp);
                // 清空上级历史记录
				$ionicHistory.nextViewOptions({
					historyRoot: true,
					disableBack: true
				});
				ExamSvr.goState('topicIndex');
			}
		};
		ExamSvr.ajax(ExamSvr.examUpdate);
    };
}
