export default ($http, $ionicLoading, $localStorage, $state, $ionicHistory) => {
  let service = {
    examList: {
      url: '/tikuapp/user/getExamInfo',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        subjectId: ''
      },
      callback: () => {}
    },
    // 相关参数值
    params: {
      userId: '',
      examId: '',
      examName: '',
      examLocation: '',
      examLocId: ''
    },
    selectList: {
      outerIndex: -1,
      innerIndex: ''
    },
    examUpdate: {
      url: '/tikuapp/user/setExamInfo',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {},
      callback: () => {}
    },
    getAreaInfo: {
      url: '/www/lib/lCalendar/area.json',
      type: 'GET',
      headers: {},
      data: {},
      callback: () => {}
    },
    /**
     * 统一AJAX 调用方法
     * @param {String} json.type 类型值
     * @param {String} json.url 接口地址
     * @param {Object} json.headers 请求头对象内容
     * @param {Object} json.data 请求内容对象
     * @param {Function} json.callback 请求结束回调函数
     */
    ajax: (json) => {
      $http({
        method: json.type,
        url: BASE_PATH + json.url,
        headers: json.headers,
        data: json.data
      }).then((data, status) => {
        json.callback && json.callback(data, status);
      }, (data, status) => {
        json.callback && json.callback(data, status);
      });
    },
    /**
     * 获取本地缓存文件中的数据    后期可提取方法 -- common 
     * @param {String} key 传入对应的变量名
     */
    getLocalItem: (key) => {
      return $localStorage[key];
    },
    /**
     * 设置本地缓存文件中的数据    后期可提取方法 -- common
     * @param {String} key 传入对应的变量名
     * @param {Object} val 传入对应的要存储的值
     */
    setLocalItem: (key, val) => {
      $localStorage[key] = val;
    },
    /**
     * 路由指向某个页面    后期可提取方法 -- common
     * @param {String} name 传入对应的变量名
     */
    goState: (name) => {
      $state.go(name);
    },
    /**
     * 返回上一级页面    后期可提取方法 -- common
     */
    goBack: () => {
      $ionicHistory.goBack();
    },
    /**
     * 系统提示框 自定义弹框 显示    后期可提取方法 -- common
     * @param {String} json.title 错误信息
     * @param {Number} json.num 错误信息
     */
    sysShow: (json) => {
      $ionicLoading.show({ template: json.title, duration: json.num });
    },
    /**
     * 系统提示框 自定义弹框 隐藏    后期可提取方法 -- common
     */
    sysHide: () => {
      $ionicLoading.hide();
    }
  };

  return service;
}
