export default ($scope, LoginSvr, $ionicHistory, $ionicPopup) => {
	$scope.userInfo = {
		phoneNumber: LoginSvr.getLocalItem('user') && Number(LoginSvr.getLocalItem('user').mobilephone) || '',
		password: LoginSvr.getLocalItem('user') && LoginSvr.getLocalItem('user').password || ''
	};
	// 提交
	$scope.submit = (str) => {
    /* 是游客身份登录 */
    if(str == 'guest') {
      $scope.userInfo.phoneNumber = 17601621101
      $scope.userInfo.password = '123456'
    }
		// 输入为空 验证
		if(LoginSvr.isNaN($scope.userInfo.phoneNumber)) {
			LoginSvr.errorPopup({ title: '请输入手机号' });
			return ;
		} else if(LoginSvr.isNaN($scope.userInfo.password)) {
			LoginSvr.errorPopup({ title: '请输入密码' });
			return ;
		}
		// AJAX 登录调用
		LoginSvr.login.data = {
			mobilePhone: $scope.userInfo.phoneNumber,
			pwd: $scope.userInfo.password
		};
		LoginSvr.login.callback = (data, status) => {
			LoginSvr.sysHide();
			if(data.data.code != 0) {
				LoginSvr.errorPopup({ title: data.data.errMsg, callback: (e) => {} });
			} else {
				data.data.data.TIKU_AUTH_TOKEN = data.headers('TIKU_AUTH_TOKEN');
        data.data.data.password = $scope.userInfo.password;
        data.data.data.guest = str == 'guest' ? true : false;
				LoginSvr.setLocalItem('user', data.data.data);
				// 清空上级历史记录
				$ionicHistory.nextViewOptions({
					historyRoot: true,
					disableBack: true
				});
				// 未填写报考信息 需要填写
				if(!LoginSvr.isNaN(LoginSvr.getLocalItem('user').examid)) {
					LoginSvr.goState('topicIndex');
				} else {
					LoginSvr.goState('examInfo');
				}
			}
		};
		LoginSvr.sysShow({ title: '登录中', num: '1000' });
		LoginSvr.ajax(LoginSvr.login);
	};

  /* 游客登录 弹框提示 */
  $scope.isGuestLogin = () => {
    $ionicPopup.show({
      title: '游客模式只能体验10道题，建议先登录',
      cssClass: 'login-errorPopup',
      buttons: [{
        text: '游客模式',
        type: 'scene-inp3',
        onTap: function(e) {
          $scope.submit('guest');
        }
      }, {
        text: '先登录',
        type: 'scene-inp3',
        onTap: function(e) {

        }
      }]
    });
  }

	// 微信授权
	// $scope.oauthLoginWechat = () => {
	// 	LoginSvr._oauthLoginWechat().then(function (data) {
	// 		return LoginSvr.ajax({
	// 			url: '/tikuapp/loginwechat',
	// 			type: 'POST',
	// 			headers: {
	// 			  'Content-Type': 'application/json'
	// 			},
	// 			data: {
	// 				code: data.code
	// 			},
	// 			callback: (data, status) => {
	// 				alert(JSON.stringify(data));
	// 			}
	// 		});
	// 	});
  // };


  // 刷新函数
  $scope.doRefresh = () => {
    if (LoginSvr.getLocalItem('user') && LoginSvr.getLocalItem('user').guest) {
      LoginSvr.setLocalItem('user', {});
    }
    $scope.userInfo.phoneNumber = LoginSvr.getLocalItem('user') && Number(LoginSvr.getLocalItem('user').mobilephone) || '';
    $scope.userInfo.password = LoginSvr.getLocalItem('user') && LoginSvr.getLocalItem('user').password || '';
    /* 打开时，只要localStorage 中有用户数据，那么直接登录 */
    if (LoginSvr.getLocalItem('user') && LoginSvr.getLocalItem('user').mobilephone && LoginSvr.getLocalItem('user').password) {
      $scope.submit();
    }
  }

  // 进入或返回该页面时，刷新页面数据
  $scope.$on('$ionicView.beforeEnter', $scope.doRefresh);
}
