export default ($scope, LoginSvr, $interval) => {
    $scope.userInfo = {};
    $scope.SMS_CODE = '获取验证码';
    // 提交
    $scope.submit = () => {
		// 输入为空 验证
		if(LoginSvr.isNaN($scope.userInfo.userName)) {
            LoginSvr.errorPopup({ title: '请输入用户名' });
			return ;
        } else if(LoginSvr.isNaN($scope.userInfo.phoneNumber)) {
			LoginSvr.errorPopup({ title: '请输入手机号' });
			return ;
		} else if(LoginSvr.isNaN($scope.userInfo.smsCode)) {
            LoginSvr.errorPopup({ title: '请输入验证码' });
            return ;
        } else if(LoginSvr.isNaN($scope.userInfo.password)) {
			LoginSvr.errorPopup({ title: '请输入新的密码' });
			return ;
		}
		// AJAX 用户注册调用
		LoginSvr.register.data = {
            userName: $scope.userInfo.userName,
			mobilePhone: $scope.userInfo.phoneNumber,
            pwd: $scope.userInfo.password,
            smscode: $scope.userInfo.smsCode
		};
		LoginSvr.register.callback = (data, status) => {
			if(data.data.code != 0) {
                LoginSvr.errorPopup({ title: data.data.errMsg, callback: (e) => {} });
            } else {
                data.data.data.TIKU_AUTH_TOKEN = data.headers('TIKU_AUTH_TOKEN');
				LoginSvr.setLocalItem('user', data.data.data);
                LoginSvr.goState('examInfo');
            }
		};
		LoginSvr.ajax(LoginSvr.register);
    };
    // 获取验证码
    let flag = 1, count = 50;
    $scope.getCode = () => {
        if(LoginSvr.isNaN($scope.userInfo.phoneNumber)) {
			LoginSvr.errorPopup({ title: '请输入手机号' });
			return ;
		}
        if(flag == 1) {
            flag = 0;
            LoginSvr.sysShow({ title: '发送中', num: '10000' });
            // AJAX 获取验证码调用
            LoginSvr.smsCode.data = {
                mobilePhone: $scope.userInfo.phoneNumber
            };
            LoginSvr.smsCode.callback = (data, status) => {
                LoginSvr.sysHide();
                if(data.data.code != 0) {
                    flag = 1;
                    LoginSvr.errorPopup({ title: data.data.errMsg, callback: (e) => {} });
                } else {
                    LoginSvr.errorPopup({ title: '验证码已发送至您的手机', callback: (e) => {
                        let temp = count;
                        $scope.SMS_CODE = temp+'s后重发';
                        $interval(() => {
                            temp -= 1;
                            $scope.SMS_CODE = temp+'s后重发';
                        }, 1000, count-1).then(() => {
                            flag = 1;
                            $scope.SMS_CODE = '获取验证码';
                        });
                    } });
                }
            };
            LoginSvr.ajax(LoginSvr.smsCode);
        }
    };
}
