export default ($http, $ionicLoading, $ionicPopup, $localStorage, $state, $q) => {
  let service = {
    login: {
      url: '/tikuapp/user/login',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json'
      },
      data: {
        mobilePhone: '',
        pwd: ''
      },
      callback: () => {}
    },
    register: {
      url: '/tikuapp/user/register',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json'
      },
      data: {
        userName: '',
        mobilePhone: '',
        pwd: '',
        smscode: ''
      },
      callback: () => {}
    },
    findpwd: {
      url: '/tikuapp/user/findbackpwd',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json'
      },
      data: {
        mobilePhone: '',
        pwd: '',
        smscode: ''
      },
      callback: () => {}
    },
    smsCode: {
      url: '/tikuapp/getSmsCode',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json'
      },
      data: {
        mobilePhone: ''
      },
      callback: () => {}
    },
    /**
     * 统一AJAX 调用方法    后期可提取方法 -- common
     * @param {String} json.type 类型值
     * @param {String} json.url 接口地址
     * @param {Object} json.headers 请求头对象内容
     * @param {Object} json.data 请求内容对象
     * @param {Function} json.callback 请求结束回调函数
     */
    ajax: (json) => {
      $http({
        method: json.type,
        url: BASE_PATH + json.url,
        headers: json.headers,
        data: json.data
      }).then((data, status) => {
        json.callback && json.callback(data, status);
      }, (data, status) => {
        json.callback && json.callback(data, status);
      });
    },
    /**
     * 判断是否为空方法    后期可提取方法 -- common
     * @param {String} val 传入对应的变量值
     */
    isNaN: (val) => {
      return (val == '' || val == undefined || val == null) ? true : false;
    },
    /**
     * 获取本地缓存文件中的数据    后期可提取方法 -- common
     * @param {String} key 传入对应的变量名
     */
    getLocalItem: (key) => {
      return $localStorage[key];
    },
    /**
     * 设置本地缓存文件中的数据    后期可提取方法 -- common
     * @param {String} key 传入对应的变量名
     * @param {Object} val 传入对应的要存储的值
     */
    setLocalItem: (key, val) => {
      $localStorage[key] = val;
    },
    /**
     * 删除本地缓存文件中的数据    后期可提取方法 -- common
     * @param {String} key 传入对应的变量名
     */
    removeLocalItem: (key) => {
      $localStorage.remove(key);
    },
    /**
     * 路由指向某个页面    后期可提取方法 -- common
     * @param {String} name 传入对应的变量名
     */
    goState: (name) => {
      $state.go(name);
    },
    /**
     * 系统提示框 自定义弹框 显示    后期可提取方法 -- common
     * @param {String} json.title 错误信息
     * @param {Number} json.num 错误信息
     */
    sysShow: (json) => {
      $ionicLoading.show({ template: json.title, duration: json.num });
    },
    /**
     * 系统提示框 自定义弹框 隐藏    后期可提取方法 -- common
     */
    sysHide: () => {
      $ionicLoading.hide();
    },
    /**
     * 错误提示框 自定义弹框
     * @param {String} json.title 错误信息
     * @param {Function} json.callback 对应回调函数
     */
    errorPopup: (json) => {
      let myPopup1 = $ionicPopup.show({
        title: json.title,
        cssClass: 'login-errorPopup',
        buttons: [{
          text: '确定',
          type: 'scene-inp3',
          onTap: function(e) {
            json.callback && json.callback(e);
          }
        }]
      });
    },
    /**
     * 微信登录 验证客户端 并 授权
     */
    _oauthLoginWechat: () => {
      let deferred = $q.defer();
      Wechat.isInstalled((installed) => {
        if (installed) {
          var scope = "snsapi_userinfo",
              state = 'wechat_sdk_demo_test';
          Wechat.auth(scope, state, (response) => {
            return deferred.resolve(response);
          }, (reason) => {
            alert('授权失败');
          });
        } else {
          alert('没有微信客户端');
          return deferred.reject('出错');
        }
      }, (reason) => {
        alert('第三方登录失败');
        return deferred.reject('出错');
      });
      return deferred.promise;
    }
  }

  return service;
}
