export default ($http, $ionicLoading, $localStorage, $state, $ionicHistory) => {
  let service = {
    getYearly: {
      url: '/tikuapp/user/getYearlySummary',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        examId: '',
        userId: ''
      },
      callback: () => {}
    },
    getSubject: {
      url: '/tikuapp/user/getSubjectList',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        examId: '',
        userId: ''
      },
      callback: () => {}
    },
    getPaper: {
      url: '/tikuapp/user/getTPaperSummary',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        examId: '',
        userId: ''
      },
      callback: () => {}
    },
    getVideoUrl: {
      tempUrl: '/tikuapp/getVideoUrl',
      url: '/tikuapp/getVideoUrl',
      type: 'GET',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {}
    },
    getWrong: {
      url: '/tikuapp/user/getErrorList',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        examId: '',
        userId: ''
      },
      callback: () => {}
    },
    // 页面相关数据
    topicData: {
      userId: '',
      title: '',
      subjectId: '',
      dataSubjectList: null,
      dataYearList: null,
      dataWrongList: null
    },
    getSearch: {
      url: '/tikuapp/user/searchChapter',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        searchKey: ''
      },
      callback: () => {}
    },
    // 按 科目获取  题目
    getChapterTiList: {
      url: '/tikuapp/user/getChapterTiList',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        userId: '',
        courseId: '',
        chapterId: '',
        type: 0   // 为1时代表  错题集
      },
      callback: () => {}
    },
    // 按 年代获取  题目
    getYearlyTiList: {
      url: '/tikuapp/user/getYearlyTiList',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        userId: '',
        yearlyId: '',
        type: 0   // 为1时代表  错题集
      },
      callback: () => {}
    },
    // 按 周末考试获取  题目
    getPaperTiList: {
      url: '/tikuapp/user/getTPaperTiList',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        userId: '',
        paperId: '',
        type: 0   // 为1时代表  错题集
      },
      callback: () => {}
    },
    // 获取题目时，需要传的参数值
    doTopic: {
      subject: {
        userId: '',
        courseId: '',
        chapterId: '',
        type: 0
      },
      yearly: {
        userId: '',
        yearlyId: '',
        type: 0
      },
      paper: {
        userId: '',
        paperId: '',
        type: 0
      },
      typeStr: 'subject', // 默认是 学科类型   yearly 为年代类型
      title: ''
    },
    submitTopic: {
      url: '/tikuapp/user/setAnswerInfo',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        userId: '',
        courseId: '',
        chapterId: '',
        answer: '',
        tid: '',
        tiSn: '',
        yearlyId: '',
        isRight: ''
      },
      callback: () => {}
    },
    collectTopic: {
      url: '/tikuapp/user/setCollectInfo',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        userId: '',
        courseId: '',
        chapterId: '',
        tid: '',
        tiSn: '',
        yearlyId: '',
      },
      callback: () => {}
    },
    cancelCollectTopic: {
      url: '/tikuapp/user/cancelCollectInfo',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {
        userId: '',
        tid: ''
      },
      callback: () => {}
    },
    doAgain: {
      url: '/tikuapp/user/resetAnswerInfo',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {},
      callback: () => {}
    },
    setShare: {
      url: '/tikuapp/user/setShareInfo',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {},
      callback: () => {}
    },
    setUsed: {
      url: '/tikuapp/user/setUsedInfo',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {},
      callback: () => {}
    },
    upPaperAllTi: {
      url: '/tikuapp/user/submitTPaper',
      type: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'TIKU_AUTH_TOKEN': ''
      },
      data: {},
      callback: () => {}
    },
    /**
     * 统一AJAX 调用方法    后期可提取方法 -- common
     * @param {String} json.type 类型值
     * @param {String} json.url 接口地址
     * @param {Object} json.headers 请求头对象内容
     * @param {Object} json.data 请求内容对象
     * @param {Function} json.callback 请求结束回调函数
     */
    ajax: (json) => {
      $http({
        method: json.type,
        url: BASE_PATH + json.url,
        headers: json.headers,
        data: json.data
      }).then((data, status) => {
        json.callback && json.callback(data, status);
      }, (data, status) => {
        json.callback && json.callback(data, status);
      });
    },
    /**
     * 判断是否为空方法    后期可提取方法 -- common
     * @param {String} val 传入对应的变量值
     */
    isNaN: (val) => {
      return (val == '' || val == undefined || val == null) ? true : false;
    },
    /**
     * 获取本地缓存文件中的数据    后期可提取方法 -- common
     * @param {String} key 传入对应的变量名
     */
    getLocalItem: (key) => {
      return $localStorage[key];
    },
    /**
     * 设置本地缓存文件中的数据    后期可提取方法 -- common
     * @param {String} key 传入对应的变量名
     * @param {Object} val 传入对应的要存储的值
     */
    setLocalItem: (key, val) => {
      $localStorage[key] = val;
    },
    /**
     * 删除本地缓存文件中的数据    后期可提取方法 -- common
     * @param {String} key 传入对应的变量名
     */
    removeLocalItem: (key) => {
      $localStorage.remove(key);
    },
    /**
     * 路由指向某个页面    后期可提取方法 -- common
     * @param {String} name 传入对应的变量名
     */
    goState: (name) => {
      $state.go(name);
    },
    /**
     * 返回上一级页面    后期可提取方法 -- common
     */
    goBack: () => {
      $ionicHistory.goBack();
    },
    /**
     * 系统提示框 自定义弹框 显示    后期可提取方法 -- common
     * @param {String} json.title 错误信息
     * @param {Number} json.num 错误信息
     */
    sysShow: (json) => {
      $ionicLoading.show({ template: json.title, duration: json.num });
    },
    /**
     * 系统提示框 自定义弹框 隐藏    后期可提取方法 -- common
     */
    sysHide: () => {
      $ionicLoading.hide();
    }
  }

  return service;

}
