export default ($scope, TopicSvr, $ionicScrollDelegate, $ionicSlideBoxDelegate, $timeout) => {
    // AJAX 渲染列表页  按学科
    let getSubjectTopic = () => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getChapterTiList.data = TopicSvr.doTopic.subject;
        TopicSvr.getChapterTiList.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getChapterTiList.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.doList = data.data.data;
                /* 游客每个章节 最多只有十道题 */
                if (TopicSvr.getLocalItem('user').guest) {
                  if ($scope.doList.length > 10) {
                    $scope.doList.splice(10, $scope.doList.length - 10)
                    console.log($scope.doList.length)
                  }
                }
                $scope.arr = [];
                curIndex = 0;
                for(let i=0; i<$scope.doList.length; i++) {
                    $scope.arr.push({
                        collect: $scope.doList[i].iscurretcollect?'已收藏':'收藏',
                        isAnswer: $scope.doList[i].answer?true:false,
                        answer: $scope.doList[i].answer || '',
                        videoUrl: $scope.doList[i].videourl,
                        isPlay: false
                    });
                    // 统计单选 多选个数
                    if($scope.doList[i].titype == 1) $scope.simpleCount += 1;
                    if($scope.doList[i].titype == 2) $scope.multiCount += 1;
                    // 处理答案
                    let answer = $scope.arr[i].answer;
                    if(answer != '') {
                        for(let j=0; j<6; j++) $scope.arr[i]['on'+j] = false;
                        if($scope.doList[i].titype == 1) { // 单选
                            switch(answer) {
                                case 'A': $scope.arr[i]['on0'] = true;break;
                                case 'B': $scope.arr[i]['on1'] = true;break;
                                case 'C': $scope.arr[i]['on2'] = true;break;
                                case 'D': $scope.arr[i]['on3'] = true;break;
                                case 'E': $scope.arr[i]['on4'] = true;break;
                                case 'F': $scope.arr[i]['on5'] = true;break;
                            }
                        } else if($scope.doList[i].titype == 2) { // 多选
                            answer += ',';
                            if(/A,/.test(answer)) { $scope.arr[i]['on0'] = true; }
                            if(/B,/.test(answer)) { $scope.arr[i]['on1'] = true; }
                            if(/C,/.test(answer)) { $scope.arr[i]['on2'] = true; }
                            if(/D,/.test(answer)) { $scope.arr[i]['on3'] = true; }
                            if(/E,/.test(answer)) { $scope.arr[i]['on4'] = true; }
                            if(/F,/.test(answer)) { $scope.arr[i]['on5'] = true; }
                        }
                        // 答题 重新进入时，直接到上一次最后答题
                        curIndex = i;
                    }
                }
                let tempCount = Math.floor($scope.doList.length / $scope.qesCount)
                for (let i = 0; i <= tempCount; i++) {
                  $scope.curDoList[i] = []
                  for (let j = $scope.qesCount * i; j < $scope.qesCount * (i + 1); j++) {
                    if ($scope.doList[j]) {
                      $scope.curDoList[i][j-$scope.qesCount*i] = $scope.doList[j]
                    }
                  }
                }
                console.log($scope.curDoList)
                TopicSvr.sysHide();
                $ionicSlideBoxDelegate.update();
            }
        };
        TopicSvr.ajax(TopicSvr.getChapterTiList);
    };

    // AJAX 渲染列表页  按年代
    let getYearlyTopic = () => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getYearlyTiList.data = TopicSvr.doTopic.yearly;
        TopicSvr.getYearlyTiList.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getYearlyTiList.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.doList = data.data.data;
                /* 游客每个章节 最多只有十道题 */
                if (TopicSvr.getLocalItem('user').guest) {
                  if ($scope.doList.length > 10) {
                    $scope.doList.splice(10, $scope.doList.length - 10)
                  }
                }
                $scope.arr = [];
                curIndex = 0;
                for(let i=0; i<$scope.doList.length; i++) {
                    $scope.arr.push({
                        collect: $scope.doList[i].iscurretcollect?'已收藏':'收藏',
                        isAnswer: $scope.doList[i].answer?true:false,
                        answer: $scope.doList[i].answer || '',
                        videoUrl: $scope.doList[i].videourl,
                        isPlay: false
                    });
                    // 统计单选 多选个数
                    if($scope.doList[i].titype == 1) $scope.simpleCount += 1;
                    if($scope.doList[i].titype == 2) $scope.multiCount += 1;
                    // 处理答案
                    let answer = $scope.arr[i].answer;
                    if(answer != '') {
                        for(let j=0; j<6; j++) $scope.arr[i]['on'+j] = false;
                        if($scope.doList[i].titype == 1) { // 单选
                            switch(answer) {
                                case 'A': $scope.arr[i]['on0'] = true;break;
                                case 'B': $scope.arr[i]['on1'] = true;break;
                                case 'C': $scope.arr[i]['on2'] = true;break;
                                case 'D': $scope.arr[i]['on3'] = true;break;
                                case 'E': $scope.arr[i]['on4'] = true;break;
                                case 'F': $scope.arr[i]['on5'] = true;break;
                            }
                        } else if($scope.doList[i].titype == 2) { // 多选
                            answer += ',';
                            if(/A,/.test(answer)) { $scope.arr[i]['on0'] = true; }
                            if(/B,/.test(answer)) { $scope.arr[i]['on1'] = true; }
                            if(/C,/.test(answer)) { $scope.arr[i]['on2'] = true; }
                            if(/D,/.test(answer)) { $scope.arr[i]['on3'] = true; }
                            if(/E,/.test(answer)) { $scope.arr[i]['on4'] = true; }
                            if(/F,/.test(answer)) { $scope.arr[i]['on5'] = true; }
                        }
                        // 答题 重新进入时，直接到上一次最后答题
                        curIndex = i;
                    }
                }
                let tempCount = Math.floor($scope.doList.length / $scope.qesCount)
                for (let i = 0; i <= tempCount; i++) {
                  $scope.curDoList[i] = []
                  for (let j = $scope.qesCount * i; j < $scope.qesCount * (i + 1); j++) {
                    if ($scope.doList[j]) {
                      $scope.curDoList[i][j-$scope.qesCount*i] = $scope.doList[j]
                    }
                  }
                }
                TopicSvr.sysHide();
                $ionicSlideBoxDelegate.update();
                $ionicSlideBoxDelegate.slide(0);
            }
        };
        TopicSvr.ajax(TopicSvr.getYearlyTiList);
    };

    // AJAX 渲染列表页  按周末考试
    let getPaperTopic = () => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getPaperTiList.data = TopicSvr.doTopic.paper;
        TopicSvr.getPaperTiList.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getPaperTiList.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.doList = data.data.data;
                /* 游客每个章节 最多只有十道题 */
                if (TopicSvr.getLocalItem('user').guest) {
                  if ($scope.doList.length > 10) {
                    $scope.doList.splice(10, $scope.doList.length - 10)
                  }
                }
                $scope.arr = [];
                curIndex = 0;
                for(let i=0; i<$scope.doList.length; i++) {
                    $scope.arr.push({
                        collect: $scope.doList[i].iscurretcollect?'已收藏':'收藏',
                        isAnswer: $scope.doList[i].answer?true:false,
                        answer: $scope.doList[i].answer || '',
                        videoUrl: $scope.doList[i].videourl,
                        isPlay: false
                    });
                    // 统计单选 多选个数
                    if($scope.doList[i].titype == 1) $scope.simpleCount += 1;
                    if($scope.doList[i].titype == 2) $scope.multiCount += 1;
                    // 处理答案
                    let answer = $scope.arr[i].answer;
                    if(answer != '') {
                        for(let j=0; j<6; j++) $scope.arr[i]['on'+j] = false;
                        if($scope.doList[i].titype == 1) { // 单选
                            switch(answer) {
                                case 'A': $scope.arr[i]['on0'] = true;break;
                                case 'B': $scope.arr[i]['on1'] = true;break;
                                case 'C': $scope.arr[i]['on2'] = true;break;
                                case 'D': $scope.arr[i]['on3'] = true;break;
                                case 'E': $scope.arr[i]['on4'] = true;break;
                                case 'F': $scope.arr[i]['on5'] = true;break;
                            }
                        } else if($scope.doList[i].titype == 2) { // 多选
                            answer += ',';
                            if(/A,/.test(answer)) { $scope.arr[i]['on0'] = true; }
                            if(/B,/.test(answer)) { $scope.arr[i]['on1'] = true; }
                            if(/C,/.test(answer)) { $scope.arr[i]['on2'] = true; }
                            if(/D,/.test(answer)) { $scope.arr[i]['on3'] = true; }
                            if(/E,/.test(answer)) { $scope.arr[i]['on4'] = true; }
                            if(/F,/.test(answer)) { $scope.arr[i]['on5'] = true; }
                        }
                        // 答题 重新进入时，直接到上一次最后答题
                        curIndex = i;
                    }
                }
                let tempCount = Math.floor($scope.doList.length / $scope.qesCount)
                for (let i = 0; i <= tempCount; i++) {
                  $scope.curDoList[i] = []
                  for (let j = $scope.qesCount * i; j < $scope.qesCount * (i + 1); j++) {
                    if ($scope.doList[j]) {
                      $scope.curDoList[i][j-$scope.qesCount*i] = $scope.doList[j]
                    }
                  }
                }
                TopicSvr.sysHide();
                $ionicSlideBoxDelegate.update();
                $ionicSlideBoxDelegate.slide(0);
            }
        };
        TopicSvr.ajax(TopicSvr.getPaperTiList);
    };

    // AJAX 提交答案  每道题提交一次
    let submitTopic = (data) => {
        TopicSvr.submitTopic.data = data;
        TopicSvr.submitTopic.headers = {
          TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.submitTopic.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                console.log('题目提交成功');
            }
        };
        TopicSvr.ajax(TopicSvr.submitTopic);
    };

    // AJAX 题目收藏
    let collectTopic = (outerIndex, data) => {
        data.userId = TopicSvr.getLocalItem('user').userid;
        TopicSvr.collectTopic.data = data;
        TopicSvr.collectTopic.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.collectTopic.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                TopicSvr.sysShow({ title: '已收藏', num: '1000' });
                $scope.arr[outerIndex]['collect'] = '已收藏';
            }
        };
        TopicSvr.ajax(TopicSvr.collectTopic);
    };
    // AJAX 题目取消收藏
    let cancelCollectTopic = (outerIndex, data) => {
        TopicSvr.cancelCollectTopic.data = {
            userId: TopicSvr.getLocalItem('user').userid,
            tid: data.tid
        };
        TopicSvr.cancelCollectTopic.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.cancelCollectTopic.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                TopicSvr.sysShow({ title: '取消收藏', num: '1000' });
                $scope.arr[outerIndex]['collect'] = '收藏';
            }
        };
        TopicSvr.ajax(TopicSvr.cancelCollectTopic);
    };

    /* 分享朋友圈 */
    $scope.share = () => {
      Wechat.isInstalled((installed) => {
        if (installed) {
          TopicSvr.sysShow({ title: '正在打开微信', num: '2000' });
          Wechat.share({
            message: {
              title: "昭昭题库，通关必备！",
              description: '',
              thumb: "www/img/logo.png",
              media: {
                type: Wechat.Type.WEBPAGE,
                webpageUrl: 'http://share.yikao88.com/app/tiku/index.html'
                // webpageUrl: BASE_PATH + "/dist/download.html"
              }
            },
            scene: Wechat.Scene.TIMELINE
          }, function () {
            TopicSvr.sysShow({ title: '分享成功', num: '1000' });
          }, function (reason) {
            alert("Failed: " + reason);
          });
        } else {
          alert('没有微信客户端');
          return deferred.reject('出错');
        }
      }, (reason) => {
        alert('第三方调用失败');
        return deferred.reject('出错');
      });
    }

    // 执行 存储模式 还是 执行 下一页
    $scope.doClick = () => {
      if($scope.lastIndex) {
        /* 如果是游客 直接 跳转登录页 */
        if (TopicSvr.getLocalItem('user').guest) {
          TopicSvr.sysShow({ title: '请先登录', num: '2000' });
          TopicSvr.setLocalItem('user', {});
          TopicSvr.goState('logIn');
          return ;
        }
        $scope.nextPage();
      } else {
        $scope.openModel();
      }
    };
    // 存储模式信息
    $scope.model = {
      title: '智能模式',
      isShow: true,
      type: 1  // 1代表智能模式 2代表解析模式
    };
    // 打开模式选择
    $scope.openModel = () => {
      $scope.model.isShow = !$scope.model.isShow;
    };
    // 选择模式
    $scope.selectModel = (type) => {
      $scope.model.title = type == 1 ? '智能模式' : '解析模式';
      $scope.model.type = type;
      $scope.model.isShow = false;
    };

    // 存储所有答题信息数组
    /**
     * 包括：
     *  1. 当前题目是否已答
     *  2. 存储需要提交的所有相关参数
     */
    $scope.arr = [];
    // 当前答题选项切换
    $scope.select = (outerIndex, index, titype, rightAnswer, _obj) => {
      // 已经解析的 不能再进行选择
      if($scope.arr[curIndex]['isAnalysis']) return ;
      let str = '';
      if(titype == 1) { // 单选
        for(let i=0; i<6; i++) $scope.arr[outerIndex]['on'+i] = false;
        $scope.arr[outerIndex]['on'+index] = true;
        switch(index) {
          case 0: str = 'A';break;
          case 1: str = 'B';break;
          case 2: str = 'C';break;
          case 3: str = 'D';break;
          case 4: str = 'E';break;
          case 5: str = 'F';break;
        }
      } else if(titype == 2) { // 多选
        $scope.arr[outerIndex]['on'+index] = !$scope.arr[outerIndex]['on'+index];
        if($scope.arr[outerIndex]['on0']) str += 'A,';
        if($scope.arr[outerIndex]['on1']) str += 'B,';
        if($scope.arr[outerIndex]['on2']) str += 'C,';
        if($scope.arr[outerIndex]['on3']) str += 'D,';
        if($scope.arr[outerIndex]['on4']) str += 'E,';
        if($scope.arr[outerIndex]['on5']) str += 'F,';
        if(str != '') str = str.substr(0, str.length-1);
      }
      // 提交题目时，所有相关参数
      $scope.arr[outerIndex]['params'] = _obj;
      $scope.arr[outerIndex].params.userId = TopicSvr.getLocalItem('user').userid;
      $scope.arr[outerIndex].params.answer = str;
      $scope.arr[outerIndex].params.isRight = (str == rightAnswer?'1':'0');
      $scope.arr[outerIndex]['isAnswer'] = true;
    }

    // 向导提示关闭
    $scope.guide = () => {
      $scope.guideVal = 1;

      $scope.curGroup = Math.floor(curIndex / $scope.qesCount)

      $ionicSlideBoxDelegate.update();
      // 关闭时，跳转到对应最后一道题目位置
      $ionicSlideBoxDelegate.slide(curIndex - $scope.curGroup * $scope.qesCount);
      // $scope.slider.slideTo(curIndex)
    }

    // 答题滑块滚动
    let curIndex = 0;
    // $scope.slideOptions = {
    //   loop: false,
    //   effect: 'slide',
    //   speed: 500
    // }
    /* 轮播图 加载完成后执行 */
    // $scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
    //   $timeout(function() {
    //     TopicSvr.sysHide()
    //   }, 1000);
    // })
    // $scope.$on("$ionicSlides.sliderInitialized", function(event, data){
    //   // data.slider is the instance of Swiper
    //   $scope.slider = data.slider;
    // });
    // $scope.$on("$ionicSlides.slideChangeEnd", (event, data) => {
      // note: the indexes are 0-based
      // $scope.activeIndex = data.slider.activeIndex;
      // $scope.previousIndex = data.slider.previousIndex;
      // let index = data.slider.activeIndex
    // });

    /* 新增 最后一个向左滑动 第一个向右滑动 监听 */
    $scope.$on('eventSwiperScrollLeft', function () {
      if (curIndex == $scope.qesCount * ($scope.curGroup + 1) - 1 && curIndex+2 <= $scope.doList.length) {
        let tempCnt = $scope.curGroup
        $scope.curGroup = 50 // 数组为空
        $timeout(function () {
          $scope.curGroup = tempCnt + 1
          $ionicSlideBoxDelegate.update();
          $timeout(function () {
            TopicSvr.sysHide();
            $ionicSlideBoxDelegate.slide(0);
          }, 200)
        }, 200)
      } else {
        TopicSvr.sysHide();
        TopicSvr.sysShow({ title: '已是最后一题', num: '1000' })
      }
    })
    $scope.$on('eventSwiperScrollRight', function () {
      if (curIndex != 0 && curIndex-1 > 0) {
        let tempCnt = $scope.curGroup
        $scope.curGroup = 50 // 数组为空
        $timeout(function () {
          $scope.curGroup = tempCnt - 1
          $ionicSlideBoxDelegate.update();
          $timeout(function () {
            TopicSvr.sysHide();
            $ionicSlideBoxDelegate.slide($scope.qesCount * ($scope.curGroup + 1) - 1);
          }, 200)
        }, 200)
      } else {
        TopicSvr.sysHide();
        TopicSvr.sysShow({ title: '已是第一题', num: '1000' })
      }
    })

    $scope.slideHasChanged = (index) => {
        /* 监听滑动，关闭视频播放 */
        let _v = document.getElementById('video'+curIndex)
        if(_v) {
          _v.pause()
        }

        // 当滑块向右滑动时，进行 题目提交, 并且当前题目已答
        if(index > curIndex && $scope.arr[curIndex]['isAnswer'] && $scope.arr[curIndex]['params']) {
            submitTopic($scope.arr[curIndex]['params']);
        }
        curIndex = index;
        // 最后一页 显示 下一步 按钮
        if(curIndex == $scope.arr.length-1) {
            $scope.lastIndex = 1;
        } else {
            $scope.lastIndex = 0;
        }
        // 每次滑动切换页面后， 滚动到顶部
        $ionicScrollDelegate.scrollTop();
    }
    // 答题到最后，进入下一页，提交页面时
    $scope.nextPage = () => {
        // 提交最后一道题
        if($scope.arr[curIndex]['isAnswer'] && $scope.arr[curIndex]['params']) {
            submitTopic($scope.arr[curIndex]['params']);
        }

        // 先判断所有题目是否已经全部答完，答完进入交卷页
        let flag = 1;
        for(let i=0; i<$scope.arr.length; i++) {
            if(!$scope.arr[i].isAnswer) flag = 0;
        }
        if(flag) {
            TopicSvr.goState('topicList');
        } else {
            TopicSvr.sysShow({ title: '还有未完成的题目', num: '1000' });
        }
    }

    // 解析查看答案
    $scope.showAnalysis = (outerIndex, titype, rightAnswer) => {
      if(!$scope.arr[curIndex]['isAnswer']) {
        TopicSvr.sysShow({ title: '请先选择答案', num: '1000' });
        return ;
      }
      // 打开解析
      $scope.arr[curIndex]['isAnalysis'] = true;
      // 显示 当前答题 是否正确，标注出来 错误正确题目
      for(let i=0; i<6; i++) $scope.arr[outerIndex]['right'+i] = false;
      for(let i=0; i<6; i++) $scope.arr[outerIndex]['wrong'+i] = true;
      if(titype == 1) { // 单选
        switch(rightAnswer) {
          case 'A': $scope.arr[curIndex]['right0'] = true;$scope.arr[curIndex]['wrong0'] = false;break;
          case 'B': $scope.arr[curIndex]['right1'] = true;$scope.arr[curIndex]['wrong1'] = false;break;
          case 'C': $scope.arr[curIndex]['right2'] = true;$scope.arr[curIndex]['wrong2'] = false;break;
          case 'D': $scope.arr[curIndex]['right3'] = true;$scope.arr[curIndex]['wrong3'] = false;break;
          case 'E': $scope.arr[curIndex]['right4'] = true;$scope.arr[curIndex]['wrong4'] = false;break;
          case 'F': $scope.arr[curIndex]['right5'] = true;$scope.arr[curIndex]['wrong5'] = false;break;
        }
      } else if(titype == 2) { // 多选
        rightAnswer += ',';
        if(/A,/.test(rightAnswer)) { $scope.arr[curIndex]['right0'] = true;$scope.arr[curIndex]['wrong0'] = false; }
        if(/B,/.test(rightAnswer)) { $scope.arr[curIndex]['right1'] = true;$scope.arr[curIndex]['wrong1'] = false; }
        if(/C,/.test(rightAnswer)) { $scope.arr[curIndex]['right2'] = true;$scope.arr[curIndex]['wrong2'] = false; }
        if(/D,/.test(rightAnswer)) { $scope.arr[curIndex]['right3'] = true;$scope.arr[curIndex]['wrong3'] = false; }
        if(/E,/.test(rightAnswer)) { $scope.arr[curIndex]['right4'] = true;$scope.arr[curIndex]['wrong4'] = false; }
        if(/F,/.test(rightAnswer)) { $scope.arr[curIndex]['right5'] = true;$scope.arr[curIndex]['wrong5'] = false; }
      }
      /* 监听是否进入后台，关闭视频播放 */
      let _v = document.getElementById('video'+curIndex)
      let closefn = () => {
        _v.pause()
      }
      if(_v) {
        document.removeEventListener('pause', closefn)
        document.addEventListener('pause', closefn)
      }
    };

    // 收藏当前题目
    $scope.collect = (outerIndex, data) => {
      if($scope.arr[outerIndex]['collect'] == '收藏') {
        collectTopic(outerIndex, data);
      } else if($scope.arr[outerIndex]['collect'] == '已收藏') {
        cancelCollectTopic(outerIndex, data);
      }
    };

    // 播放或暂停 当前视频
    $scope.playOrPause = (that) => {
      // debugger
    }
     // 获取 视频地址
    $scope.getUrl = (outerIndex) => {
      TopicSvr.sysShow({ title: '加载中', num: '5000' });
      TopicSvr.getVideoUrl.url = TopicSvr.getVideoUrl.tempUrl + '?videoId=' + $scope.arr[outerIndex].videoUrl
      TopicSvr.getVideoUrl.headers = {
        TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
      };
      TopicSvr.getVideoUrl.callback = (data, status) => {
        if(data.data.code != 0) {
          TopicSvr.sysHide();
          TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
        } else {
          TopicSvr.sysHide();
          $scope.arr[outerIndex].videoUrl = data.data.data.video.copy[0].playurl
          $scope.arr[outerIndex].isPlay = true
        }
      };
      TopicSvr.ajax(TopicSvr.getVideoUrl);
    }

    $scope.doList = {};
    $scope.title = TopicSvr.doTopic.title;
    $scope.simpleCount = 0;
    $scope.multiCount = 0;
    // 刷新   有些问题
    $scope.doRefresh = () => {
        // 每次 初始化
        $scope.noModel = false;
        $scope.model = { title: '解析模式', isShow: true, type: 2 };
        $scope.guideVal = 0;
        $scope.title = TopicSvr.doTopic.title;
        $scope.simpleCount = 0;
        $scope.multiCount = 0;
        /* 当前显示题目数组 */
        $scope.curDoList = []
        /* 目前按20题目为一组，当前在第0组 */
        $scope.qesCount = 20
        $scope.curGroup = 0

        // 重新调用接口
        if(TopicSvr.doTopic.typeStr == 'subject') {
            getSubjectTopic();
        } else if(TopicSvr.doTopic.typeStr == 'yearly') {
            getYearlyTopic();
        } else if(TopicSvr.doTopic.typeStr == 'paper') {
            // 特殊处理  -- 没有模式
            $scope.noModel = true;
            $scope.model = { title: '智能模式', isShow: true, type: 1 };
            getPaperTopic();
        }
    };

    // 进入或返回该页面时，刷新页面数据
    $scope.$on('$ionicView.afterEnter', $scope.doRefresh);
    /* 在退出页面时 */
    $scope.$on('$ionicView.beforeLeave', () => {
      $scope.curDoList = []
    });
}
