export default ($scope, TopicSvr, $timeout) => {
    $scope.topicData = TopicSvr.topicData;
    // 搜索 模型
    $scope.search = {
        val: '',
        dataList: []
    };
    // 清空搜索内容
    $scope.clearInput = () => {
        $scope.search.val = '';
    };
    // 搜索内容调用
    let timerHandler = null;
    $scope.changeInput = () => {
        if($scope.search.val) {
            $timeout.cancel(timerHandler);
            timerHandler = $timeout(() => {
                getSearch();
            }, 500);
        }
    };
    // 一级 控制 按搜索内容
    $scope.itemSearch = {};
    // 一级列表 展开收起切换 按搜索内容
    $scope.selectToggle2 = (val) => {
        $scope.itemSearch[val] = !$scope.itemSearch[val];
    };
    // 按学科 数据模型
    $scope.list1 = {};
    // 按年代 数据模型
    $scope.list2 = {};
    // 周末考试 数据模型
    $scope.list3 = {};
    // 错题集 数据模型
    $scope.list4 = {};
    // 学科切换 初始化
    $scope.sArr = { item1: 1, item2: 0, item3: 0, item4: 0 };
    // 学科切换 函数
    $scope.switch = (i1, i2, i3, i4) => {
        $scope.sArr.item1 = i1;
        $scope.sArr.item2 = i2;
        $scope.sArr.item3 = i3;
        $scope.sArr.item4 = i4;
        $scope.sArr.item1 && getSubject();
        $scope.sArr.item2 && getYearly();
        $scope.sArr.item3 && getPaper();
        $scope.sArr.item4 && getWrong();
    };
    // 学习进度 数据模型
    $scope.learn = {
        percent: 0,
        totalCount: 0,
        rightCount: 0,
        wrongCount: 0,
        complateCount: 0,
        title: '',
        percentLeft: 0,
        percentRight: 0
    };
    // 一级 控制 按学科
    $scope.item = {};
    // 一级列表 展开收起切换 按学科
    $scope.selectToggle = (val) => {
        $scope.item[val] = !$scope.item[val];
    };
    // 一级 控制 按错题
    $scope.itemList4 = {};
    // 一级列表 展开收起切换 按错题
    $scope.selectToggle1 = (val) => {
        $scope.itemList4[val] = !$scope.itemList4[val];
    };
    // 去做题页面
    $scope.goDoTopic = (obj) => {
        if(obj.typeStr == 'subject') { // 表示学科
            TopicSvr.doTopic.subject = {
                userId: TopicSvr.getLocalItem('user').userid,
                courseId: obj._obj.courseId,
                chapterId: obj._obj.chapterId,
                type: obj.type
            }
        } else if(obj.typeStr == 'yearly') { // 表示年代
            TopicSvr.doTopic.yearly = {
                userId: TopicSvr.getLocalItem('user').userid,
                yearlyId: obj._obj.yearlyId,
                type: obj.type
            }
        } else if(obj.typeStr == 'paper') { // 表示周末考试
            var papermode = $scope.list3[obj.index].papermode;
            switch(papermode) {
                case '0':
                    // 不在考试时间范围之内，不能做题
                    var time = new Date().getTime();
                    if($scope.list3[obj.index].begindt > time || $scope.list3[obj.index].enddt < time) {
                        TopicSvr.sysShow({title: '抱歉，不在考试时间内试卷已关闭', num: 1000});
                        return ;
                    }
                    break;
                case '1':
                    // 答题机会用完，不能做题
                    if($scope.list3[obj.index].dupcnt <= $scope.list3[obj.index].hasUsedCnt) {
                        TopicSvr.sysShow({title: '抱歉，你的做题机会已用完', num: 1000});
                        return ;
                    }
                    setUsed($scope.list3[obj.index].id);
                    break;
                case '2':
                    // 分享次数不够，不能做题
                    if($scope.list3[obj.index].sharecnt > $scope.list3[obj.index].hasShareCnt) {
                        openShare($scope.list3[obj.index].id);
                        return ;
                    }
                    break;
            }

            TopicSvr.doTopic.paper = {
                userId: TopicSvr.getLocalItem('user').userid,
                paperId: obj._obj.paperId,
                type: obj.type
            }
        }
        TopicSvr.doTopic.title = obj.title;
        TopicSvr.doTopic.typeStr = obj.typeStr;
        TopicSvr.goState('topicDo');
    }
    // 去错题解析页面
    $scope.goTopicAnalysis = (obj) => {
        // 查看解析页，将相关数据存入localStorage，通过动态改变localStorage数据, 改变解析页面中数据
        TopicSvr.setLocalItem('topic', {
            title: obj.title,
            typeStr: obj.typeStr,
            subject: {
                userId: TopicSvr.getLocalItem('user').userid,
                courseId: obj._obj.courseId,
                chapterId: obj._obj.chapterId,
                type: obj.type
            },
            yearly: {
                userId: TopicSvr.getLocalItem('user').userid,
                yearlyId: obj._obj.yearlyId,
                type: obj.type
            },
            paper: {
                userId: TopicSvr.getLocalItem('user').userid,
                paperId: obj._obj.paperId,
                type: obj.type
            }
        });
        TopicSvr.goState('topicAnalysis');
    };

    // 刷新函数
    $scope.doRefresh = () => {
        TopicSvr.topicData.title = TopicSvr.getLocalItem('user').examname;
        if($scope.search.val) {
            getSearch();
        } else {
            $scope.sArr.item1 && getSubject();
            $scope.sArr.item2 && getYearly();
            $scope.sArr.item3 && getPaper();
            $scope.sArr.item4 && getWrong();
        }
    };

    // AJAX 渲染列表页  按学科
    let getSubject = () => {
        // TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getSubject.data = {
            examId: TopicSvr.getLocalItem('user').examid,
            userId: TopicSvr.getLocalItem('user').userid
        };
        TopicSvr.getSubject.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getSubject.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.list1 = data.data.data;
                $scope.learn.totalCount = 0;
                $scope.learn.complateCount = 0;
                $scope.learn.wrongCount = 0;
                $scope.learn.rightCount = 0;
                $scope.learn.percent = (0).toFixed(1);
                $scope.learn.percentRight = '45deg';
                $scope.learn.percentLeft = '-135deg';
                for(let i=0; i<$scope.list1.length; i++) {
                    $scope.learn.totalCount += $scope.list1[i].ticnt;
                    $scope.learn.complateCount += $scope.list1[i].tiCompleteCnt;
                    $scope.learn.wrongCount += $scope.list1[i].tiErrCnt;
                    $scope.learn.rightCount += $scope.list1[i].tiRightCnt;
                }
                if($scope.learn.totalCount) $scope.learn.percent = ($scope.learn.complateCount/$scope.learn.totalCount*100).toFixed(1) == 100?100:($scope.learn.complateCount/$scope.learn.totalCount*100).toFixed(1);
                if($scope.learn.percent < 50) {
                    $scope.learn.percentRight = -135+18/5*$scope.learn.percent + 'deg';
                    $scope.learn.percentLeft = '-135deg';
                } else {
                    $scope.learn.percentRight = '45deg';
                    $scope.learn.percentLeft = (-135+18/5*($scope.learn.percent-50)) + 'deg';
                }
                $scope.learn.title = '学科综合测试';
                // TopicSvr.sysHide();
            }
        };
        TopicSvr.ajax(TopicSvr.getSubject);
    };

    // AJAX 渲染列表页  按年代
    let getYearly = () => {
        // TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getYearly.data = {
            examId: TopicSvr.getLocalItem('user').examid,
            userId: TopicSvr.getLocalItem('user').userid
        };
        TopicSvr.getYearly.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getYearly.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.list2 = data.data.data;
                $scope.learn.totalCount = 0;
                $scope.learn.complateCount = 0;
                $scope.learn.wrongCount = 0;
                $scope.learn.rightCount = 0;
                $scope.learn.percent = (0).toFixed(1);
                $scope.learn.percentRight = '45deg';
                $scope.learn.percentLeft = '-135deg';
                for(let i=0; i<$scope.list2.length; i++) {
                    $scope.learn.totalCount += $scope.list2[i].ticnt;
                    $scope.learn.complateCount += $scope.list2[i].tiCompleteCnt;
                    $scope.learn.wrongCount += $scope.list2[i].tiErrCnt;
                    $scope.learn.rightCount += $scope.list2[i].tiRightCnt;
                }
                if($scope.learn.totalCount) $scope.learn.percent = ($scope.learn.complateCount/$scope.learn.totalCount*100).toFixed(1) == 100?100:($scope.learn.complateCount/$scope.learn.totalCount*100).toFixed(1);
                if($scope.learn.percent < 50) {
                    $scope.learn.percentRight = -135+18/5*$scope.learn.percent + 'deg';
                    $scope.learn.percentLeft = '-135deg';
                } else {
                    $scope.learn.percentRight = '45deg';
                    $scope.learn.percentLeft = (-135+18/5*($scope.learn.percent-50)) + 'deg';
                }
                $scope.learn.title = '年代综合测试';
                // TopicSvr.sysHide();
            }
        };
        TopicSvr.ajax(TopicSvr.getYearly);
    };

    // AJAX 渲染列表页 按周末考试
    let getPaper = () => {
        TopicSvr.getPaper.data = {
            examId: TopicSvr.getLocalItem('user').examid,
            userId: TopicSvr.getLocalItem('user').userid
        };
        TopicSvr.getPaper.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getPaper.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.list3 = data.data.data;
                $scope.learn.totalCount = 0;
                $scope.learn.complateCount = 0;
                $scope.learn.wrongCount = 0;
                $scope.learn.rightCount = 0;
                $scope.learn.percent = (0).toFixed(1);
                $scope.learn.percentRight = '45deg';
                $scope.learn.percentLeft = '-135deg';
                for(let i=0; i<$scope.list3.length; i++) {
                    $scope.learn.totalCount += $scope.list3[i].ticnt;
                    $scope.learn.complateCount += $scope.list3[i].tiCompleteCnt;
                    $scope.learn.wrongCount += $scope.list3[i].tiErrCnt;
                    $scope.learn.rightCount += $scope.list3[i].tiRightCnt;
                }
                if($scope.learn.totalCount) $scope.learn.percent = ($scope.learn.complateCount/$scope.learn.totalCount*100).toFixed(1) == 100?100:($scope.learn.complateCount/$scope.learn.totalCount*100).toFixed(1);
                if($scope.learn.percent < 50) {
                    $scope.learn.percentRight = -135+18/5*$scope.learn.percent + 'deg';
                    $scope.learn.percentLeft = '-135deg';
                } else {
                    $scope.learn.percentRight = '45deg';
                    $scope.learn.percentLeft = (-135+18/5*($scope.learn.percent-50)) + 'deg';
                }
                $scope.learn.title = '周末考试综合测试';
            }
        };
        TopicSvr.ajax(TopicSvr.getPaper);
    };

    // AJAX 渲染列表页  按错题集
    let getWrong = () => {
        // TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getWrong.data = {
            examId: TopicSvr.getLocalItem('user').examid,
            userId: TopicSvr.getLocalItem('user').userid
        };
        TopicSvr.getWrong.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getWrong.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.list4 = data.data.data;
                // TopicSvr.sysHide();
                if(!$scope.list4.length) {
                    TopicSvr.sysShow({ title: '暂无错题', num: '1000' });
                }
            }
        };
        TopicSvr.ajax(TopicSvr.getWrong);
    };

    // AJAX 渲染列表页  搜索
    let getSearch = () => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getSearch.data = {
            searchKey: $scope.search.val,
            examId: TopicSvr.getLocalItem('user').examid
        };
        TopicSvr.getSearch.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getSearch.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.search.dataList = data.data.data;
                TopicSvr.sysHide();
            }
        };
        TopicSvr.ajax(TopicSvr.getSearch);
    };

    // 分享控制
    $scope.isShare = false
    $scope.isShareShow = false
    $scope.curPaperId = ''
    // 关闭分享
    $scope.closeShare = () => {
        $scope.isShare = false
        setTimeout(() => {
            $scope.isShareShow = false
        }, 450);
    }
    // 打开分享
    let openShare = (paperId) => {
        $scope.isShareShow = true
        $scope.isShare = true
        $scope.curPaperId = paperId
    }
    // 调用分享
    $scope.share = (index) => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.setShare.data = {
            paperId: $scope.curPaperId,
            userId: TopicSvr.getLocalItem('user').userid,
            shareCnt: ''
        };
        TopicSvr.setShare.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.setShare.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: '分享成功', num: '1000' });
                $scope.doRefresh();
            }
        };
        Wechat.isInstalled((installed) => {
            if (installed) {
                Wechat.share({
                    message: {
                        title: "医考巴巴",
                        description: "我在这里进行周末考试，快来参与吧！",
                        thumb: "www/img/logo.png",
                        media: {
                            type: Wechat.Type.LINK,
                            // webpageUrl: BASE_PATH + "/dist/index.html"
                            webpageUrl: 'http://share.yikao88.com/app/tiku/index.html'
                        }
                    },
                    scene: index
                }, function () {
                    TopicSvr.ajax(TopicSvr.setShare);
                }, function (reason) {
                    alert("Failed: " + reason);
                });
            } else {
                alert('没有微信客户端');
                return deferred.reject('出错');
            }
        }, (reason) => {
            alert('第三方调用失败');
            return deferred.reject('出错');
        });
    }
    // 调用答题使用
    let setUsed = (paperId) => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.setUsed.data = {
            paperId: paperId,
            userId: TopicSvr.getLocalItem('user').userid,
            usedCnt: ''
        };
        TopicSvr.setUsed.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.setUsed.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                TopicSvr.sysHide();
            }
        };
        TopicSvr.ajax(TopicSvr.setUsed);
    }


    // 进入或返回该页面时，刷新页面数据
    $scope.$on('$ionicView.beforeEnter', $scope.doRefresh);
}
