export default ($scope, TopicSvr) => {
    // AJAX 渲染列表页  按学科
    let getSubjectTopic = () => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getChapterTiList.data = TopicSvr.doTopic.subject;
        TopicSvr.getChapterTiList.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getChapterTiList.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.doList = data.data.data;
                TopicSvr.sysHide();
            }
        };
        TopicSvr.ajax(TopicSvr.getChapterTiList);
    };

    // AJAX 渲染列表页  按年代
    let getYearlyTopic = () => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getYearlyTiList.data = TopicSvr.doTopic.yearly;
        TopicSvr.getYearlyTiList.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getYearlyTiList.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.doList = data.data.data;
                TopicSvr.sysHide();
            }
        };
        TopicSvr.ajax(TopicSvr.getYearlyTiList);
    };

    // AJAX 渲染列表页  按周末考试
    let getPaperTopic = () => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getPaperTiList.data = TopicSvr.doTopic.paper;
        TopicSvr.getPaperTiList.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getPaperTiList.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.doList = data.data.data;
                TopicSvr.sysHide();
            }
        };
        TopicSvr.ajax(TopicSvr.getPaperTiList);
    };

    // AJAX 重新做  返回做题页面
    $scope.doAgain = () => {
        TopicSvr.sysShow({ title: '重置中', num: '5000' });
        if(TopicSvr.doTopic.typeStr == 'subject') {
            TopicSvr.doAgain.data = TopicSvr.doTopic.subject;
        } else if(TopicSvr.doTopic.typeStr == 'yearly') {
            TopicSvr.doAgain.data = TopicSvr.doTopic.yearly;
        } else if(TopicSvr.doTopic.typeStr == 'paper') {
            TopicSvr.doAgain.data = TopicSvr.doTopic.paper;
        }
        TopicSvr.doAgain.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.doAgain.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                TopicSvr.sysHide();
                TopicSvr.goBack();
            }
        };
        TopicSvr.ajax(TopicSvr.doAgain);
    };

    // 获取样式
    $scope.getStyle = (outerIndex) => {
        return {
            'width': Math.floor(59/375*screen.width)+'px',
            'height': Math.floor(59/375*screen.width)+'px',
            'line-height': Math.floor(59/375*screen.width)+'px',
            'margin': ('0 0 '+Math.floor(15/375*screen.width)+'px '+Math.floor(15/375*screen.width)+'px'),
            'margin-left': (outerIndex%5 == 0?'0':'')
        }
    }
    // 跳转 去 题目报告页面
    $scope.goTopicReport = () => {
        // 如果为周末考试，那么需要提交试卷，再跳转
        if(TopicSvr.doTopic.typeStr == 'paper') {
            let answer = '';
            let score = 0;
            for(let i=0; i<$scope.doList.length; i++) {
                if($scope.doList[i].isright) {
                    score += parseInt($scope.doList[i].tipoint);
                }
                answer += (($scope.doList[i].answer == ''?'0':$scope.doList[i].answer) + ';');
            }
            TopicSvr.sysShow({ title: '提交中', num: '5000' });
            TopicSvr.upPaperAllTi.data = {
                paperId: TopicSvr.doTopic.paper.paperId,
                userId: TopicSvr.doTopic.paper.userId,
                point: score,
                answer: answer
            };
            TopicSvr.upPaperAllTi.headers = {
                TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
            };
            TopicSvr.upPaperAllTi.callback = (data, status) => {
                if(data.data.code != 0) {
                    TopicSvr.sysHide();
                    TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
                } else {
                    TopicSvr.sysHide();
                    TopicSvr.goState('topicReport');
                }
            };
            TopicSvr.ajax(TopicSvr.upPaperAllTi);
            return ;
        }
        TopicSvr.goState('topicReport');
    };

    // 刷新函数
    $scope.doRefresh = () => {
        $scope.doList = {};
        $scope.title = TopicSvr.doTopic.title;
        if(TopicSvr.doTopic.typeStr == 'subject') {
            getSubjectTopic();
        } else if(TopicSvr.doTopic.typeStr == 'yearly') {
            getYearlyTopic();
        } else if(TopicSvr.doTopic.typeStr == 'paper') {
            getPaperTopic();
        }
    }

    // 进入或返回该页面时，刷新页面数据
    $scope.$on('$ionicView.beforeEnter', $scope.doRefresh);
}
