export default ($scope, TopicSvr) => {
    // AJAX 渲染列表页  按学科
    let getSubjectTopic = () => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getChapterTiList.data = TopicSvr.doTopic.subject;
        TopicSvr.getChapterTiList.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getChapterTiList.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.doList = data.data.data;
                $scope.totalCount = $scope.doList.length;
                $scope.rightCount = 0;
                $scope.score = 0;
                for(let i=0; i<$scope.doList.length; i++) {
                    if($scope.doList[i].isright) {
                        $scope.rightCount += 1;
                        $scope.score += parseInt($scope.doList[i].tipoint);
                    }
                }
                $scope.time = new Date();
                TopicSvr.sysHide();
            }
        };
        TopicSvr.ajax(TopicSvr.getChapterTiList);
    };

    // AJAX 渲染列表页  按年代
    let getYearlyTopic = () => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getYearlyTiList.data = TopicSvr.doTopic.yearly;
        TopicSvr.getYearlyTiList.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getYearlyTiList.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.doList = data.data.data;
                $scope.totalCount = $scope.doList.length;
                $scope.rightCount = 0;
                $scope.score = 0;
                for(let i=0; i<$scope.doList.length; i++) {
                    if($scope.doList[i].isright) {
                        $scope.rightCount += 1;
                        $scope.score += parseInt($scope.doList[i].tipoint);
                    }
                }
                $scope.time = new Date();
                TopicSvr.sysHide();
            }
        };
        TopicSvr.ajax(TopicSvr.getYearlyTiList);
    };

    // AJAX 渲染列表页  按周末考试
    let getPaperTopic = () => {
        TopicSvr.sysShow({ title: '加载中', num: '5000' });
        TopicSvr.getPaperTiList.data = TopicSvr.doTopic.paper;
        TopicSvr.getPaperTiList.headers = {
            TIKU_AUTH_TOKEN: TopicSvr.getLocalItem('user').TIKU_AUTH_TOKEN
        };
        TopicSvr.getPaperTiList.callback = (data, status) => {
            if(data.data.code != 0) {
                TopicSvr.sysHide();
                TopicSvr.sysShow({ title: data.data.errMsg, num: '1000' });
            } else {
                $scope.doList = data.data.data;
                $scope.totalCount = $scope.doList.length;
                $scope.rightCount = 0;
                $scope.score = 0;
                for(let i=0; i<$scope.doList.length; i++) {
                    if($scope.doList[i].isright) {
                        $scope.rightCount += 1;
                        $scope.score += parseInt($scope.doList[i].tipoint);
                    }
                }
                $scope.time = new Date();
                TopicSvr.sysHide();
            }
        };
        TopicSvr.ajax(TopicSvr.getPaperTiList);
    };

    // 获取样式
    $scope.getStyle = (outerIndex) => {
        return {
            'width': Math.floor(59/375*screen.width)+'px',
            'height': Math.floor(59/375*screen.width)+'px',
            'line-height': Math.floor(59/375*screen.width)+'px',
            'margin': ('0 0 '+Math.floor(15/375*screen.width)+'px '+Math.floor(15/375*screen.width)+'px'),
            'margin-left': (outerIndex%5 == 0?'0':'')
        }
    }
 
    $scope.goTopicAnalysis = (obj) => {
        // 查看解析页，将相关数据存入localStorage，通过动态改变localStorage数据, 改变解析页面中数据
        TopicSvr.setLocalItem('topic', {
            title: $scope.title,
            typeStr: TopicSvr.doTopic.typeStr,
            subject: {
                userId: TopicSvr.doTopic.subject.userId,
                courseId: TopicSvr.doTopic.subject.courseId,
                chapterId: TopicSvr.doTopic.subject.chapterId,
                type: obj.type
            },
            yearly: {
                userId: TopicSvr.doTopic.yearly.userId,
                yearlyId: TopicSvr.doTopic.yearly.yearlyId,
                type: obj.type
            },
            paper: {
                userId: TopicSvr.doTopic.paper.userId,
                paperId: TopicSvr.doTopic.paper.paperId,
                type: obj.type  
            }
        });
        TopicSvr.goState('topicAnalysis');
    };

    // 刷新函数
    $scope.doRefresh = () => {
        $scope.doList = {};
        $scope.title = TopicSvr.doTopic.title;
        if(TopicSvr.doTopic.typeStr == 'subject') {
            getSubjectTopic();
        } else if(TopicSvr.doTopic.typeStr == 'yearly') {
            getYearlyTopic();
        } else if(TopicSvr.doTopic.typeStr == 'paper') {
            getPaperTopic();
        }
    }

    // 进入或返回该页面时，刷新页面数据
    $scope.$on('$ionicView.beforeEnter', $scope.doRefresh);
}
